
var map={}
var mouseX=0, mouseY=0, screenX=0, screenY=0, lastMouseX=0, lastMouseY=0, movementX=0, movementY=0

_=function(q){return document.querySelector(q)};

onkeydown = onkeyup = function(e){
	e = e || event; // IE
    map[e.key] = e.type == 'keydown';
	if(['ArrowDown', 'ArrowLeft', 'ArrowRight', 'ArrowUp'].indexOf(e.key)>-1){e.preventDefault()}
}

document.pointerLockElement = document.pointerLockElement || document.mozPointerLockElement || document.webkitPointerLockElement;
document.exitPointerLock = document.exitPointerLock || document.mozExitPointerLock || document.webkitExitPointerLock;

setMouseVariables=function(e){
	lastMouseX=mouseX==0 ? e.screenX : mouseX;
	lastMouseY=mouseY==0 ? e.screenY : mouseY;
	mouseX=e.screenX;
	mouseY=e.screenY;
}
 
var havePointerLock = 'pointerLockElement' in document || 'mozPointerLockElement' in document || 'webkitPointerLockElement' in document;
window.addEventListener("mousemove", function(e){
	setMouseVariables(e)
	if(havePointerLock && document.pointerLockElement){
		movementX = e.movementX;
		movementY = -e.movementY;
	}
	else{
		movementX = mouseX - lastMouseX;
		movementY = lastMouseY - mouseY;
	}
});


Environment3d=function(theaterDiv){
	var self=this
	
	this.setView=function(){
		this.view=createElement('div', {'className':'view'})
		this.wrap.appendChild(this.view)
	}
	
	this.setWorld=function(){
		this.world=new Object3D()
		this.world.collidable=false;
		this.world.name="world"
		this.world.wrap.className="wrap-object3d world"
		this.view.appendChild(this.world.wrap)
		this.world.parent=this
	    this.world.theater=this;
		this.world.originCamera=true;
	}
	
	this.addObject=function(obj){
		if(obj.type=="skybox"){
			obj.parent=self//objet
			this.skybox=obj
		}
		else{	
			obj.parent=this.world;//objet
			obj.repere.setAbsoluteRepereChildren()
		}
		if((obj.type=="perso")&&(obj.camera)){
			this.addObject(obj.camera);
		}
		this.objects.push(obj)
		this.addCollidable(obj)			
		obj.parent.wrap.appendChild(obj.wrap);//dom element			
		obj.theater=this;
		for(var i=0;i<obj.children.length;i++){
			obj.children[i].theater=this;
		}
		obj.view=this.view;
		obj.render()
	}
	
	
	//si obj.collidable==true : l'object plein est un obstacle. Ses "enfants" (faces) ne sont pas ajoutés comme obstacles
	//si obj.collidable==false : l'object plein n'est pas solide, mais ses enfants peuvent l'être. Exemple : cube avec faces absentes. Les faces sont ajoutées comme obstacles séparément.
	//si solid=false : ni l'object ni ses children ne sont des obstacles.
	
	this.addCollidable=function(obj){
		if(!obj.solid){return;}
		if(!this.collidables){this.collidables=[]}
		if(!this.collidables.containObject(obj)){
			if(obj.collidable){
				this.collidables.push(obj);
				obj.updateHitbox();
			}
			else if(obj.children.length>0){
				for(var i=0;i<obj.children.length;i++){
					this.addCollidable(obj.children[i])
				}
			}
		}
	}
	
	this.handleResize=function(){
		var H=window.innerHeight
		var W=window.innerWidth
		
		var w=self.width//self.wrap.offsetWidth
		var h=self.height//self.wrap.offsetHeight
		
		var ratio=Math.min(W/w, H/h,1)
		if(ratio<1){
			self.wrap.style.transformOrigin="left top"
			self.wrap.style.transform="scale(" + ratio + ")"
		}
		else{
			self.wrap.style.transform=""
		}
		self.wrap.style.marginLeft=((W-w*ratio)/2)+"px"
	}
	
	this.init=function(theaterDiv){
		this.wrap=theaterDiv
		this.name="theater"
		this.setView()
		this.setWorld()
		this.height=this.world.wrap.offsetHeight;
		this.width=this.world.wrap.offsetWidth;
		this.y0=0;//niveau du sol
		this.x0=0;//origine x
		this.z0=0;//origine y
		this.objects=[];
		
		this.camera0=new Camera(this.width/2, this.height/2, -800, 0, 0, 0, 800)
		this.camera0.id="camera0";
		this.camera0.name="camera0";
		this.camera=this.camera0;
		this.addObject(this.camera)
		this.camera.activate()
		
		this.world.setXYZ(0,0,0,0,0,0)//compenser le changement de variable
		this.world.setTransformOriginFPS();
		if(!Environment3d.animationId){Environment3d.loop();}
		
		//capture curseur souris
		theaterDiv.onclick=function(e){
			theaterDiv.requestPointerLock()		
		}
		
		window.addEventListener('resize',function(){
			self.handleResize();
		})
		this.handleResize()
	}
	
	this.init(theaterDiv)
}

Environment3d.controllers=[]
Environment3d.addController=function(controller){
	this.controllers.push(controller);
}
Environment3d.loop=function(){
	for(var i=0;i<Environment3d.controllers.length;i++){
		Environment3d.controllers[i].test()
	}		
	
	Environment3d.animationId=requestAnimationFrame(Environment3d.loop);
}


Object3D=function(x,y,z){
	var self=this;
		
	//repère css avec axe y vers le bas et z vers l'utilisateur
	//on utilise x,y,z pour un repère en bas à gauche, et xCss, yCss, zCss pour interagir avec la CSS
	//attention, x,y,z sont relatifs au parent, sauf pour world qui bouge avec la caméra (coordonnées absolues utiles seulement pour css)
	this.setXYZ=function(x,y,z,rx,ry,rz,xo,yo,zo){
		this.xprev2=this.xprev
		this.yprev2=this.yprev
		this.zprev2=this.zprev
		this.xprev=this.x
		this.yprev=this.y
		this.zprev=this.z
		this.x=x
		this.y=y
		this.z=z
		
		this.setAbsoluteXYZ(x,y,z)
		
		this.xCss=x;
		this.yCss=-y//this.theater.height - y
		this.zCss=-z
		if(rx!=null){
			this.setRXYZ(rx,ry,rz,xo,yo,zo)
		}
	}
		
	this.setRXYZ=function(rx,ry,rz,xo,yo,zo){
		this.rxprev=this.rx
		this.ryprev=this.ry
		this.rzprev=this.rz
		this.rx=rx
		this.ry=ry
		this.rz=rz
		this.rCss={}
		this.rCss.x=-rx
		this.rCss.y=ry
		this.rCss.z=rz
		if(xo!=null){
			this.setXYZO(xo,yo,zo);
		}
	}
	this.setXYZO=function(xo,yo,zo){
		this.xo=xo
		this.yo=yo
		this.zo=zo
		this.xoCss=xo
		this.yoCss=typeof(yo)=="string" ? yo : this.height-yo
		this.zoCss=typeof(zo)=="string" ? zo :  -zo;
	}
	
	//ne pas utiliser directement sur des objets contenus avant leur parent...
	this.setAbsoluteXYZ=function(x,y,z){
		this.xabsprev2=this.xabsprev
		this.yabsprev2=this.yabsprev
		this.zabsprev2=this.zabsprev
		this.xabsprev=this.xabs
		this.yabsprev=this.yabs
		this.zabsprev=this.zabs
		
		if(this.name=="world"){
			this.xabs=0;
			this.yabs=0;
			this.zabs=0;
			return;
		}
		
		if(!this.parent || this.parent.name=="theater"){
			this.xabs=x
			this.yabs=y
			this.zabs=z
			return;
		}
		
		else{	
			//rotation dans repère mobile + translation
			var M=vecSum(vecProd(-this.xo, this.repere.u), vecProd(-this.yo, this.repere.v), vecProd(-this.zo, this.repere.w), this.posO(), this.pos())
			//rotation dans repère parent + position origine parent
			if(this.parent.name!="world"){
				var M=vecSum(vecProd(M[0]-this.parent.xo, this.parent.repere.uabs), vecProd(M[1]-this.parent.yo, this.parent.repere.vabs), vecProd(M[2]-this.parent.zo, this.parent.repere.wabs), this.parent.posO(), this.parent.pos())
			}
			this.xabs=M[0]
			this.yabs=M[1]
			this.zabs=M[2]
		}
		if(this.updateHitbox){
			this.updateHitbox();			
		}
		
		for(var i=0;i<this.children.length;i++){
			this.children[i].setAbsoluteXYZ(this.children[i].x, this.children[i].y, this.children[i].z)
		}
		
		
	}
	
	this.setWrap=function(){
		this.wrap=createElement("div", {"className":"wrap-object3d", "id":this.type+'-'+this.id})
		this.move(this.x, this.y, this.z, this.rx, this.ry, this.rz)
	}
	
	this.addObject=function(obj){
		obj.parent=this;//objet
		this.children.push(obj);
		obj.view=this.view;//objet
		obj.theater=this.theater;//objet
		this.wrap.appendChild(obj.wrap);//dom element
	}
	
	this.elements=function(){
		return this.wrap.childNodes
	}
		
	this.setTransformOrigin=function(xo="center", yo="center", zo=0, x_unity="px", y_unity="px", z_unity="px"){
		if(x_unity=='%'){
			xo*=this.width/100;
		}
		if(y_unity=='%'){
			yo*=this.height/100;
		}
				
		if(typeof(xo)=="string"){
			switch(xo){
				case "left":
					xo=0
				break;
				case "center":
					xo=this.width/2
				break;
				case "right":
					xo=this.width
				break;
				default:
					throw("mauvaise valeur pour xo (x-origin)")
				break
				
			}
			switch(yo){
				case "top":
					yo=this.height
				break;
				case "bottom":
					yo=0
				break;
				case "center":
					yo=this.height/2
				break;
				default:
					throw("mauvaise valeur pour yo (y-origin)")
				break
				
			}
		}
		
		x_unity="px";
		y_unity="px";
		//CORRECTIF POURRI
		if(this.type=="box" || this.type=="cube"){
			this.setXYZO(xo,yo+this.height,zo);			
		}
		else{
			this.setXYZO(xo,yo,zo);
		}
		// this.setXYZO(xo,yo,zo);
		
		if(typeof(yo)=="string"){y_unity="";}
		if(typeof(zo)=="string"){z_unity="";}
		
		this.wrap.style.transformOrigin = this.xoCss + x_unity+" " + this.yoCss + y_unity+" "+ this.zoCss + z_unity	
	}
	
	this.setTransformOriginFPS=function(){
		this.setTransformOrigin(-this.x+this.theater.width/2, -this.y-this.theater.height/2, -this.z-this.theater.camera.perspective, 'px', 'px', 'px');
	}
	
	this.rotateTo=function(rx=0,ry=0,rz=0,xo="center", yo="center", zo=0, x_unity="%", y_unity="%", z_unity="px"){
		this.setRXYZ(rx,ry,rz,xo,yo,zo);
		var css=this.wrap.style.transform
		if(css.indexOf("rotate")>-1){
			css=css.replace(/rotate.?\([^)]*\)/gi, '').trim()
		}
		this.wrap.style.transform = css + " rotateX(" + rx + "deg) rotateY(" + ry + "deg) rotateZ("	 + rz + "deg)"
	}	
	
	
	this.unmove=function(){
		this.x=this.xprev
		this.y=this.yprev
		this.z=this.zprev
		this.xprev=this.xprev2
		this.yprev=this.yprev2
		this.zprev=this.zprev2
		this.xCss=this.x;
		this.yCss=-this.y//this.theater.height - y
		this.zCss=-this.z
		this.xabs=this.xabsprev
		this.yabs=this.yabsprev
		this.zabs=this.zabsprev
		this.xabsprev=this.xabsprev2
		this.yabsprev=this.yabsprev2
		this.zabsprev=this.zabsprev2
	}

	//ordre : 3 rotations (selon rotate order) puis translations
	this.move=function(x,y,z,rx, ry, rz){
		this.repere.rotate(rx,ry,rz,this.rotateOrder)
		this.repere.setAbsoluteRepere()
		this.setXYZ(x,y,z,rx,ry,rz)
		if(this.solid && this.collider){
			var icollide=this.collider.test_collisions(this.theater.collidables);
			if(icollide > -1){
				this.unmove()
			}
		}
		
		//une caméra active ne bouge plus, c'est le monde qui bouge : 
		if(this.active){return;}
		
		var tcss="translate3d(" + this.xCss + "px," + this.yCss + "px,"+ this.zCss + "px) ";
		var rcss=""
		for(var i=0;i<this.rotateOrder.length;i++){
			var k=this.rotateOrder[i]
			rcss = "rotate" + k.toUpperCase() + "(" + this.rCss[k] + "deg) " + rcss
		}
		this.wrap.style.transform = tcss + rcss
	}
	
	this.pos=function(){
		return [this.x, this.y, this.z]
	}
	
	this.posO=function(){
		return [this.xo, this.yo, this.zo]
	}
	
	this.posPrev=function(){
		return [this.xprev, this.yprev, this.zprev]
	}
	this.posAbs=function(){
		return [this.xabs, this.yabs, this.zabs]
	}
	
	
	//M matrice sous forme d'une liste de 9 valeurs dans l'ordre des lignes
	//t vecteur translation
	this.transformMatrix=function(M, t, r){
		this.setXYZ(t[0],t[1],t[2], r[0], r[1], r[2])// M est calculé à partir de r dans Repère
		
		this.wrap.style.transform = "matrix3d(" + M[0] + "," + M[1] + "," + M[2] + ", 0 , "  + M[3] + "," + M[4] + "," + M[5] + ",0 ," + M[6] + "," + M[7] + "," + M[8] + ", 0, " + this.xCss + ", " + this.yCss + ", "+ this.zCss + ",1)"
	}

	this.addCollider=function(){
		if(!this.collider){
			this.collider=new Collider(this);			
		}
	}
	
	this.render=function(){
		this.move(this.x,this.y,this.z,this.rx,this.ry,this.rz)
	}
	
	this.init=function(x=0,y=0,z=0){
		this.type="object-3d"
		this.collidable=true;
		this.parent=null
		this.children=[]
		this.theater={'width':0,'height':0};//pour initialiser les coordonnées
		this.setXYZ(x,y,z,0,0,0,0,0,0)
		this.width=0;
		this.height=0;
		this.depth=0;
		/*en cas de déplacement*/
		this.dx=10;
		this.dy=10;
		this.dz=10;
		this.drx=5;
		this.dry=5;
		this.drz=5;
		this.rotateOrder=['x','z','y']
		
		this.originCamera=false;
		Object3D.lastId+=1;
		this.id=Object3D.lastId;
		this.repere=new Repere(this);
		this.setWrap()
		this.solid=true;
	}
	
	this.init(x,y,z)
}
Object3D.lastId=-1;

Box=function(x,y,z,width, height, depth, texture){
	var self=this;
	Object3D.call(this, x, y, z);
	
	this.setElements=function(){
		var nfaces=0;
		if(this.texture.front){
			this.front=new Rectangle(0, 0, 0, this.width, this.height, this.texture.front)
			this.front.setTransformOrigin('center', 'bottom')			
			this.front.name="face front"
			this.addObject(this.front)
			nfaces+=1;
		}
		if(this.texture.back){
			this.back=new Rectangle(0, 0, 0 , this.width, this.height, this.texture.back)
			this.back.wrap.className+=" back"
			this.back.setTransformOrigin('center', 'bottom')
			this.back.move(0,0,this.depth,0,180,0)			
			this.back.name="face back"
			this.addObject(this.back)
			nfaces+=1;
		}
		if(this.texture.top){
			this.top=new Rectangle(0, 0, 0, this.width, this.depth, this.texture.top)
			this.top.name="face top"
			this.top.wrap.className+=" top"
			this.top.setTransformOrigin('left', 'bottom')
			this.top.move(0,0,0,-90,0,0)
			this.top.move(0,this.height,0,-90,0,0)
			this.addObject(this.top)
			nfaces+=1;
		}
		if(this.texture.bottom){
			this.bottom=new Rectangle(0, 0, 0, this.width, this.depth, this.texture.bottom)
			this.bottom.wrap.className+=" bottom"
			this.bottom.setTransformOrigin('center', 'bottom')		
			// this.bottom.move(0,0,this.depth,90, 0, 0)			
			this.bottom.move(0,0,this.depth,90, 0, 0)			
			this.bottom.name="face bottom"
			this.addObject(this.bottom)
			nfaces+=1;
		}
		
		if(this.texture.left){
			this.left=new Rectangle(0, 0, 0, this.depth, this.height, this.texture.left)
			this.left.wrap.className+=" left"
			this.left.setTransformOrigin('left', 'center')
			this.left.move(0, 0, this.depth, 0, 270, 0)			
			this.left.name="face left"
			this.addObject(this.left)
			nfaces+=1;
		}
		if(this.texture.right){
			this.right=new Rectangle(0, 0, 0, this.depth, this.height, this.texture.right)
			this.right.wrap.className+=" right"
			this.right.setTransformOrigin('left', 'center')
			this.right.move(this.width,0,0,0,90,0)			
			this.right.name="face right"
			this.addObject(this.right)
			nfaces+=1;
		}
		this.wrap.className+=" box"
		if(nfaces<6){
			this.collidable=false;
		}
	}
	
	this.setNormals=function(){
		this.normals={}
		this.normals.front=vecOp(this.repere.wabs)
		this.normals.back=this.repere.wabs
		this.normals.top=this.repere.vabs
		this.normals.bottom=vecOp(this.repere.vabs)
		this.normals.left=vecOp(this.repere.uabs)
		this.normals.right=this.repere.uabs
	}
	
	this.setCenters=function(){
		this.centers={}
		var width_2_u = vecProd(this.width/2, this.repere.uabs)
		var height_2_v= vecProd(this.height/2, this.repere.vabs)
		var depth_2_w= vecProd(this.depth/2, this.repere.wabs)
		
		this.centers.front=vecSum(this.posAbs(), width_2_u, height_2_v)
		this.centers.back=vecSum(this.centers.front, vecProd(2, depth_2_w))
		
		this.centers.bottom=vecSum(this.posAbs(), width_2_u, depth_2_w)
		this.centers.top=vecSum(this.centers.bottom, vecProd(2, height_2_v))
		
		this.centers.left=vecSum(this.posAbs(), height_2_v, depth_2_w)
		this.centers.right=vecSum(this.centers.bottom, vecProd(2, width_2_u))
		
		this.center=vecSum([this.x, this.y, this.z], vecProd(this.width/2, this.repere.uabs), vecProd(this.height/2, this.repere.vabs), vecProd(this.depth/2, this.repere.wabs))
	}
	
	this.setPoints=function(){
		this.points=[]
		var width_u = vecProd(this.width, this.repere.uabs)
		var height_v= vecProd(this.height, this.repere.vabs)
		var depth_w= vecProd(this.depth, this.repere.wabs)
			
		this.points.push(this.posAbs())//enveloppe 0 1 2
		this.points.push(vecSum(this.posAbs(), width_u))//enveloppe 0
		this.points.push(vecSum(this.posAbs(),width_u, height_v))
		this.points.push(vecSum(this.posAbs(),height_v))//enveloppe 1
		
		this.points.push(vecSum(this.points[0], depth_w)) ////enveloppe 2
		this.points.push(vecSum(this.points[1], depth_w))
		this.points.push(vecSum(this.points[2], depth_w))
		this.points.push(vecSum(this.points[3], depth_w))
	}
	
	this.setEnveloppe=function(){
		this.enveloppe=[0,1,0,2,0,4]
	}
	
	this.updateHitbox=function(){
		this.setCenters()
		this.setNormals()
		if(!this.enveloppe){
			this.setEnveloppe()
		}
		this.setPoints()
	}
	
	this._move=this.move
	this.move=function(x,y,z,rx, ry, rz){
		this._move(x,y,z,rx, ry, rz)
		if(this.collidable){this.updateHitbox()}
	}
	
	this.init=function(x=0 ,y=0 ,z=0, width=0, height=0, depth=0,texture=texture_null){
		this.width=width
		this.height=height
		this.depth=depth
		this.type="box"
		this.name="box"
		if(!texture){this.texture=texture_null;}
		if(typeof(texture)=='string'){texture = new Texture(texture);}
		if(typeof(texture)=='object' && texture.hasOwnProperty('type') && texture.type=='texture'){
			this.texture={'front':texture, 'back':texture, 'top':texture, 'bottom':texture, 'left':texture, 'right':texture}
		}
		else{
			this.texture=texture
		}
		
		this.setElements()
		this.setTransformOrigin(this.width/2, this.height/2, this.depth/2, 'px', 'px', 'px')
	}
	
	this.init(x,y,z,width,height,depth,texture)
}

Cube=function(x,y,z,h,texture){
		Box.call(this,x,y,z,h,h,h,texture);
		this.wrap.className+="cube"
		this.type="cube"
		this.name="cube"
}

Point=function(x,y,z, color){
	this.init=function(x,y,z,color="red"){
		var texture_point=new Texture({'background-color':color, "border":"1px solid black", "background-size": "5px"})
		Cube.call(this, x-2, y-2, z-2, 4, texture_point);
		this.x=x;
		this.y=y;
		this.z=z;
		this.type="point";
		this.name="point";
		this.wrap.className="wrap-object3d point"
		this.collidable=false;
		this.solid=false
	}
	this.init(x,y,z,color)
}

Rectangle=function(x, y, z, w, h, texture){
	var self=this;
	Object3D.call(this, x, y, z);
	
	this.setElements=function(){
		var el=createElement("div", {'className':'face'})
		el.style.width=typeof(w)=='string' ? w : w+"px"
		el.style.height=typeof(h)=='string' ? h : h+"px"
		this.move(x,y,z)
		this.texture.apply(el)
		
		this.wrap.appendChild(el)
		this.wrap.className+=" rectangle"
	}
	
	this.setPoints=function(){
		this.points=[]
		var width_u = vecProd(this.width, this.repere.uabs)
		var height_v= vecProd(this.height, this.repere.vabs)
		this.points.push(this.posAbs())//enveloppe 0 1 2
		this.points.push(vecSum(this.posAbs(), width_u))//enveloppe 0
		this.points.push(vecSum(this.posAbs(), width_u, height_v))
		this.points.push(vecSum(this.posAbs(), height_v))//enveloppe 1
	}
	
	this.setEnveloppe=function(){
		if(!this.enveloppe){
			this.enveloppe=[0,1,0,2];
		}
	}
	
	this.setNormal=function(){
		this.normal=vecOp(this.repere.wabs);
	}
	
	this.setCenter=function(){
		this.center=vecSum(this.posAbs(), vecProd(this.width/2, this.repere.uabs), vecProd(this.height/2, this.repere.vabs))
	}
	
	this._move=this.move
	this.move=function(x,y,z,rx, ry, rz){
		this._move(x,y,z,rx, ry, rz)
		if(this.collidable){
			this.updateHitbox()			
		}
	}
	
	this.updateHitbox=function(){
		this.setCenter()
		this.setNormal()
		if(!this.enveloppe){
			this.setEnveloppe()
		}
		this.setPoints()
	}
	
	this.init=function(x=0, y=0, z=0, w=100, h=100, texture=texture_null){
		this.texture=new Texture(texture)
		
		this.setElements()
		this.type="rectangle"
		this.name="rectangle"
		this.width=w;
		this.height=h;
		this.depth=0;
		this.setTransformOrigin('center', "center")
	}
	this.init(x, y, z, w, h, texture)
}

Skybox=function(img, faces){	
	var self=this
	Object3D.call(this);
	
	this.setTextureCube=function(){
		this.texture={}
		if(this.faces.front){
			this.texture.front=new Texture({'url':this.img, 'background-position':'33.333333% 50%', 'background-size': '400% 300%'})			
		}
		
		if(this.faces.left){
			this.texture.left=new Texture({'url':this.img, 'background-position':'0% 50%', 'background-size': '400% 300%'})
		}
		if(this.faces.right){
			this.texture.right=new Texture({'url':this.img, 'background-position':'66.666667% 50%', 'background-size': '400% 300%'})
		}
		
		if(this.faces.back){
			this.texture.back=new Texture({'url':this.img, 'background-position':'100% 50%', 'background-size': '400% 300%'})
		}
		
		if(this.faces.top){
			this.texture.top=new Texture({'url':this.img, 'background-position':'33.3333333% 0%', 'background-size': '400% 300%'})
		}
		if(this.faces.bottom){
			this.texture.bottom=new Texture({'url':this.img, 'background-position':'33.3333333% 100%', 'background-size': '400% 300%'})
		}
	}
	
	this.init=function(img = "images/skybox0.png", faces={top:true, bottom:true, right:true, left:true, front:true, back:true}){
		this.collidable=false;
		this.img=img
		this.h=2000
		this.faces=faces
		this.setTextureCube()
		this.type='skybox';
		this.name='skybox';
		this.wrap.className="skybox"
		
		this.wrap.style.perspective="800px";
		
		this.active=false;//activé au premier render	
		this.solid=false;
		this.collidable=false;
	}
	
	this.setCube=function(){
		
		this.perspective=this.theater.perspective
		
		//this.theater.world.move(-this.x + this.theater.width/2, -this.y + this.theater.height/2 , -this.z-this.perspective, -this.rx, -this.ry,-this.rz)

		this.cube=new Cube(this.theater.width/2 - this.h/2, - this.h/2+ this.theater.height/2, -this.perspective - this.h/2, this.h, this.texture)
		
		//le 3*this.h/2 en y rajouté à la rasbaï est lié au CORRECTIF POURRI
		this.cube.setTransformOrigin(this.h/2,this.h/2, this.h/2 ,'px','px','px')
		this.addObject(this.cube)
		
		this.controller=new Controller();
		this.controller.keys_actions["any"]=this.render
		this.controller.addMouseControls(this.render)
	}
	
	//attention, créer des contrôles de caméra avant la skybox pour éviter le décalage
	this.render=function(){
		if(!self.active){self.active=true; self.setCube()}
		self.cube.rotateOrder=self.theater.world.rotateOrder
		var rx=self.theater.world.rx
		var ry=self.theater.world.ry
		var rz=self.theater.world.rz
		var x=self.cube.x
		var y=self.cube.y
		var z=self.cube.z
		
		self.cube.move(x, y, z, rx, ry, rz);
	}
	
	this.init(img, faces)
}

//perspective : recul de la caméra sur l'axe z
Camera=function(x,y,z,rx, ry,rz, perspective){
	Object3D.call(this, x, y, z, rx, ry, rz);
	
	this.setTarget=function(focale=100){
		this.focale=focale;
		
		this.pointOrigin=new Point(0,0,0 ,'white')
		this.pointOrigin.wrap.className+=" point-origin"
		this.addObject(this.pointOrigin)
		
		this.pointTarget=new Point(0,0,0+this.focale ,'blue')
		this.pointTarget.wrap.className+=" point-target"
		this.pointTarget.wrap.querySelectorAll('.face').forEach(function(r){r.innerHTML="Z";})
		this.addObject(this.pointTarget)
		
		this.pointTargetX=new Point(0+this.focale,0,0 ,'green')
		this.pointTargetX.wrap.className+=" point-target"
		this.pointTargetX.wrap.querySelectorAll('.face').forEach(function(r){r.innerHTML="X"})
		this.addObject(this.pointTargetX)
		
		this.pointTargetY=new Point(0,0+this.focale ,0,'red')
		this.pointTargetY.wrap.className+=" point-target"
		this.pointTargetY.wrap.querySelectorAll('.face').forEach(function(r){r.innerHTML="Y"})
		this.addObject(this.pointTargetY)		
	}
	
	
	/*Une caméra activée doit sortir du world pour ne pas être déplacée par le world lorsqu'il bouge.... objet fixe*/
	this.activate=function(){
		this.theater.camera.active=false;
		
		this.theater.camera.wrap.setAttribute("active", "false");
		this.theater.world.wrap.appendChild(this.theater.camera.wrap)
		
		this.theater.perspective=this.perspective;
		this.view.style.perspective=this.perspective + "px"
		this.active=true;
		this.theater.camera=this;
		this.wrap.setAttribute("active", 'true')
				
		this.theater.world.rotateOrder=this.rotateOrder.slice().reverse()
		
		//placer objet caméra hors world (fixed)

		this.theater.wrap.appendChild(this.wrap)
		
		this.render()
	}
	
	this.deactivate=function(){	
		this.active=false;
		this.wrap.setAttribute("active", 'false')
		this.theater.world.wrap.appendChild(this.wrap)
		this.theater.camera0.activate()
		this.render()
	}
	
	this._move=this.move
	this.move=function(x,y,z,rx, ry, rz){
		rx=Math.min(Math.max(rx, -90),90)
		rz=Math.min(Math.max(rz, -10),10)//limite la casse...
		
		this._move(x,y,z,rx, ry, rz)
		if(!this.active){return;}
		this.theater.world.move(-this.x + this.theater.width/2, -this.y + this.theater.height/2 , -this.z-this.perspective, -this.rx, -this.ry,-this.rz)
		this.theater.world.setTransformOriginFPS();
	}
	
	this.setMode=function(mode){
		if(this.controller){
			return this.controller.setMode(mode)
		}
	}
	
	this.angleObject=function(obj){
		var vec_obj=vec(obj.posAbs(), this.pos())
		var ry=Math.atan2(vec_obj[2], vec_obj[0])*180/Math.PI
		
		return ry
	}
	
	
	this.init=function(x,y,z,rx=0,ry=0,rz=0, perspective=800){
		this.collidable=false;
		this.type="camera"
		this.name="camera"
		this.perspective=perspective
		this.setTarget()
		this.repere=new Repere(this)
		this.wrap.className+=" camera"
		this.active=false;
		this.solid=false;
	}
	
	this.init(x,y,z,rx,ry,rz,perspective)
}

Perso=function(x,y,z,height,controller_param){
	var self=this;
	Camera.call(this, x, y+height, z);
	
	this.init=function(x,y,z,height){
		this.type="perso"
		this.name="perso"
		this.height=height
		
		this.solid=true;
		this.addCollider();
		
		//créer controles avant la skybox (qui crée ses propres controles)
		this.controller=new Controller();
		this.controller_param=controller_param ? controller_param:{'move-right':'ArrowRight', 'move-left':'ArrowLeft', 'move-front':'ArrowDown', 'move-back':'ArrowUp', 'rotate-up':'8', 'rotate-down':'2', 'rotate-right':'6', 'rotate-left':'4', 'rotate-front':'7', 'rotate-back':'9' };
		this.controller.setCameraControls(this, this.controller_param)
	}
	this.init(x,y,z,height)
}

Repere=function(object){
	
	this.rotate=function(rx, ry, rz, rotateOrder){
		var crx=cosd(rx)
		var srx=sind(rx)
		var cry=cosd(ry)
		var sry=sind(ry)
		var crz=cosd(rz)
		var srz=sind(rz)
	    
		
		//repère indirect :
		switch(rotateOrder.join('')){
			case "xyz"://'xyz':
				// 'xyz':
				this.u=[cry*crz, -cry*srz, sry]
				this.v=[crz*srx*sry+crx*srz, -srx*sry*srz+crx+crz, -cry*srx] 
				this.w=[-crx*crz*sry+srx*srz, crx*sry*srz+crz*srx, crx*cry]
			break;
			case 'xzy':
				// 'xzy':
				this.u=[cry*crz, -srz, crz*sry]
				this.v=[crx*cry*srz+srx*sry, crx*crz, crx*sry*srz-cry*srx]
				this.w=[-cry*srx*srz-crx*sry, crz*srx, srx*sry*srz+crx*cry]
			break;
			case 'yxz':
				// 'yxz':
				this.u=[srx*sry*srz+cry*crz, crz*srx*sry-cry*srz, crx*sry]
				this.v=[crx*srz, crx*crz, -srx]
				this.w=[cry*srx*srz-crz*sry, cry*crz*srx+sry*srz, crx*cry]
			break
			case 'yzx':
				// 'yzx': OK
				this.u=[cry*crz, -crx*cry*srz+srx*sry, cry*srx*srz+crx*sry]
				this.v=[srz, crx*crz, -crz*srx]
				this.w=[-crz*sry, crx*sry*srz+cry*srx, -srx*sry*srz+crx*cry]
			break
			case 'zxy':
				// 'zxy': OK
				this.u=[-srx*sry*srz+cry*crz, -crx*srz, cry*srx*srz+crz*sry]
				this.v=[crz*srx*sry+cry*srz , crx*crz, -cry*crz*srx+sry*srz]
				this.w=[-crx*sry , srx, crx*cry]
			break
			case 'zyx':
				// 'zyx': OK
				this.u=[cry*crz, crz*srx*sry - crx*srz, crx*crz*sry + srx*srz]
				this.v=[cry*srz, srx*sry*srz + crx*crz ,crx*sry*srz-crz*srx ] 
				this.w=[-sry, cry*srx, crx*cry]	
			break
			default:
				throw "mauvais ordre"
			break
		}
		this.setHorizontalRepere();
	}
	
	this.setAbsoluteRepere=function(){
		if(!this.object.parent){return;}
		var repere0=this.object.parent.repere;
		if(!repere0){return;}
		if(this.object.parent=='theater'){
			this.uabs=this.u
			this.vabs=this.v
			this.wabs=this.w
		}
		else{
			this.uabs=[repere0.uabs[0]*this.u[0] + repere0.vabs[0]*this.u[1] + repere0.wabs[0]*this.u[2], repere0.uabs[1]*this.u[0] + repere0.vabs[1]*this.u[1] + repere0.wabs[1]*this.u[2], repere0.uabs[2]*this.u[0] + repere0.vabs[2]*this.u[1] + repere0.wabs[2]*this.u[2] ]
			this.vabs=[repere0.uabs[0]*this.v[0] + repere0.vabs[0]*this.v[1] + repere0.wabs[0]*this.v[2], repere0.uabs[1]*this.v[0] + repere0.vabs[1]*this.v[1] + repere0.wabs[1]*this.v[2], repere0.uabs[2]*this.v[0] + repere0.vabs[2]*this.v[1] + repere0.wabs[2]*this.v[2] ]
			this.wabs=[repere0.uabs[0]*this.w[0] + repere0.vabs[0]*this.w[1] + repere0.wabs[0]*this.w[2], repere0.uabs[1]*this.w[0] + repere0.vabs[1]*this.w[1] + repere0.wabs[1]*this.w[2], repere0.uabs[2]*this.w[0] + repere0.vabs[2]*this.w[1] + repere0.wabs[2]*this.w[2] ]
		}
		this.setAbsoluteRepereChildren()
	}
	
	this.setAbsoluteRepereChildren=function(){
		if(this.object.parent && this.object.parent.name!="theater"){		
			for(var i=0;i<this.object.children.length;i++){
				this.object.children[i].repere.setAbsoluteRepere(this);
			}
		}
	}
	
	//renvoie les 3 vecteurs d'un repère orthonormé [uxz, vxz, wxz] pour le déplacement FPS :
	//vxz = [0,1,0] vecteur vertical 
	//[uxz, wxz] ortho direct dans le plan horizontal (Oxz)
	//uxz projeté normé de u dans (Oxz)
	//wxz projeté normé de w dans (Oxz)
	this.setHorizontalRepere=function(){
		this.uxz=[this.u[0], 0, this.u[2]].normalize();
		this.vxz=[0,1,0];
		this.wxz=[this.w[0], 0, this.w[2]].normalize();
	}
	
	this.applyVector=function(vec){
		return [this.u[0]*vec[0] + this.v[0]*vec[1] + this.w[0]*vec[2], this.u[1]*vec[0] + this.v[1]*vec[1] + this.w[1]*vec[2], this.u[2]*vec[0] + this.v[2]*vec[1] + this.w[2]*vec[2]];
	}
	
	this.matrix=function(){
		return [this.u[0],this.v[0],this.w[0],this.u[1],this.v[1],this.w[1],this.u[2],this.v[2],this.w[2]]
	}
	
	this.pos=function(){
		return [this.u, this.v, this.w]
	}
	this.posAbs=function(){
		return [this.uabs, this.vabs, this.wabs]
	}
	
	//angles d'Euler :
	//
	//_ru, _rv, _rw les angles de rotation dans le repère mobile (u,v,w)
	//renvoie rx, ry, rz angles de rotation équivalents dans repère fixe (i,j,k)
	//ordre des rotations : x, y, z -> R = Rz Ry Rx
	this.angleEuler=function(){
		var rx1,rx2,rx, ry, rz
		
		rx=Math.atan2(this.v[2], this.w[2]);
		
		if(this.u[2]!=1 && this.u[2]!=-1){
			var ry1=-Math.asin(this.u[2])
			var ry2=Math.PI-ry1
			var c1=Math.cos(ry1)
			var c2=-c1
			rz1=Math.atan2(this.u[1]/c1, this.u[0]/c1)
			rz2=Math.atan2(this.u[1]/c2, this.u[0]/c2)
			
			ry=ry2
			rz=rz2
		}
		else{
			rz=0
			if(this.u[2]==-1){
				console.log("angle Y +pi/2")
				ry=Math.PI/2
				rz=rx+Math.atan(this.v[0], this.w[0])
			}
			else{
				console.log("angle Y -pi/2")
				ry=-Math.PI/2
				rz=-rx+Math.atan(-this.v[0], -this.w[0])
			}
		}
		return [rx*180/Math.PI, ry*180/Math.PI, rz*180/Math.PI]
	}
	
	this.init=function(object){
		this.u=[1,0,0]
		this.v=[0,1,0]
		this.w=[0,0,1]
		this.uabs=[1,0,0]
		this.vabs=[0,1,0]
		this.wabs=[0,0,1]
		this.object=object
		this.type="repere"
	}
	
	this.init(object)
}

Texture=function(attributes){
	this.apply=function(el){
		for(var attr in this.attributes){
			var val=this.attributes[attr];
			switch(attr){
				case 'url':
					el.style.background="url('" + val + "')";					
				break;
				default:
					el.style[attr]=val;
				break;
			}
		}
	
	}
	this.init=function(attributes){
		this.type='texture';
		//texture déjà définie
		if(attributes.hasOwnProperty('type') && attributes.type=='texture'){
			return attributes;
		}
		//texture définie par l'url d'une image (étiré 100%)
		else if(typeof attributes=='string' && (/\.[A-Za-z0-9]+$/.test(attributes))){
			this.attributes={
				'url':attributes,
				'background-size':'100% 100%'
			}
			return this
		}
		//texture simple couleur
		else if(typeof attributes=='string' && attributes[0]=="#"){
			this.attributes={
				'background-color':attributes
			}
			return this
		}
		//texture définie par objet descriptif
		else{
			this.attributes=attributes;
			return this;
		}
	}
	return this.init(attributes)
}
var texture_null=new Texture({'background-color':"#CCC", "border":"1px solid black"})

Controller = function(){
	var self=this;
	this.addMouseControls=function(mouseMove, mouseClick, mouseRightClick){	
		this.mouseMove=mouseMove;
		
		//_('.theater')
		window.addEventListener("mousemove", function(e){
			self.mouseMove();
			return false;
		})
	}
	
	this.setControls=function(object){
		object.controller=this;
		for(var key in this.keys_actions){
			var action=this.keys_actions[key]
			this.add(key, action)
		}
	}
	
	this.setMode=function(mode='freecam'){
		if(['fps', "freecam"].indexOf(mode)==-1){
			throw "mode caméra inconnu : " + mode + " ('fps' ou 'freecam')";
		}
		this.mode=mode;
		switch(this.mode){
			case "freecam":
				this.u1DirName="u"
				this.u2DirName="v"
				this.u3DirName="w"
			break;
			case "fps":
				this.u1DirName="uxz"
				this.u2DirName="vxz"
				this.u3DirName="wxz"
			break;	
		}
	}
	
	this.setDirections=function(){
		this.dxFront=function(object){return -object.dx * self.repere[self.u3DirName][0];}
		this.dyFront=function(object){return -object.dy * self.repere[self.u3DirName][1];}
		this.dzFront=function(object){return -object.dz * self.repere[self.u3DirName][2];}
		
		this.dxBack=function(object){return object.dx * self.repere[self.u3DirName][0];}
		this.dyBack=function(object){return object.dy * self.repere[self.u3DirName][1];}
		this.dzBack=function(object){return object.dz * self.repere[self.u3DirName][2];}
		
		this.dxLeft=function(object){return -object.dx * self.repere[self.u1DirName][0];}
		this.dyLeft=function(object){return -object.dy * self.repere[self.u1DirName][1];}
		this.dzLeft=function(object){return -object.dz * self.repere[self.u1DirName][2];}
		
		this.dxRight=function(object){return object.dx * self.repere[self.u1DirName][0];}
		this.dyRight=function(object){return object.dy * self.repere[self.u1DirName][1];}
		this.dzRight=function(object){return object.dz * self.repere[self.u1DirName][2];}
		
		this.dxUp=function(object){return object.dx * self.repere[self.u2DirName][0];}
		this.dyUp=function(object){return object.dy * self.repere[self.u2DirName][1];}
		this.dzUp=function(object){return object.dz * self.repere[self.u2DirName][2];}
		
		this.dxDown=function(object){return -object.dx * self.repere[self.u2DirName][0];}
		this.dyDown=function(object){return -object.dy * self.repere[self.u2DirName][1];}
		this.dzDown=function(object){return -object.dz * self.repere[self.u2DirName][2];}
	}
	
	//ex : actions={'move-up':"ArrowUp", 'move-down':"ArrowDown", 'move-left':"ArrowLeft", 'move-right':"ArrowRight", ...]
	this.setAbsoluteControls=function(object, actions){		
		if(object.repere){self.repere=object.repere;}
		else{
			self.repere=new Repere(self);
		}
		object.controller=self;
		for(action in actions){
			var key=actions[action]
			
			switch(action){
				case "move-up":
					self.keys_actions[key]=function(){object.move(object.x + self.dxUp(object), object.y + self.dyUp(object), object.z+ self.dzUp(object), object.rx, object.ry, object.rz)}
				break;
				case "move-down":
					self.keys_actions[key]=function(){object.move(object.x + self.dxDown(object), object.y + self.dyDown(object), object.z+self.dzDown(object), object.rx, object.ry, object.rz)}
				break;
				case "move-left":
					self.keys_actions[key]=function(){object.move(object.x + self.dxLeft(object), object.y + self.dyLeft(object), object.z + self.dzLeft(object), object.rx, object.ry, object.rz)}
				break;
				case "move-right":
					self.keys_actions[key]=function(){object.move(object.x+self.dxRight(object), object.y+self.dyRight(object), object.z+self.dzRight(object), object.rx, object.ry, object.rz)}
				break;
				case "move-front":
					self.keys_actions[key]=function(){object.move(object.x+self.dxFront(object), object.y+self.dyFront(object), object.z+self.dzFront(object), object.rx, object.ry, object.rz)}
				break;
				case "move-back":
					self.keys_actions[key]=function(){object.move(object.x+self.dxBack(object), object.y+self.dyBack(object), object.z+self.dzBack(object), object.rx, object.ry, object.rz)}
				break;
				case "rotate-up":
					self.keys_actions[key]=function(){object.move(object.x, object.y, object.z, object.rx - object.drx, object.ry, object.rz)}
				break;
				case "rotate-down":
					self.keys_actions[key]=function(){object.move(object.x, object.y, object.z, object.rx + object.drx, object.ry, object.rz)}
				break;
				case "rotate-left":
					self.keys_actions[key]=function(){object.move(object.x, object.y, object.z, object.rx, object.ry + object.dry, object.rz)}
				break;
				case "rotate-right":
					self.keys_actions[key]=function(){object.move(object.x, object.y, object.z, object.rx, object.ry - object.dry, object.rz)}
				break;
				case "rotate-front":
					self.keys_actions[key]=function(){object.move(object.x, object.y, object.z, object.rx, object.ry, object.rz-object.drz)}
				break;
				case "rotate-back":
					self.keys_actions[key]=function(){object.move(object.x, object.y, object.z, object.rx, object.ry, object.rz+object.drz)}
				break;
				default:
					self.keys_actions[action]=actions[action]//cas où action est une touche et la valeur est une fonction...
				break;
			}
		}	
		// this.setControls(object);
	}
	
	this.setCameraControls=function(camera, actions, mode="freecam"){
		this.mouseMove=function(){
				self.repere=camera.repere
				camera.move(camera.x, camera.y, camera.z, camera.rx + self.mouse_sensibility*camera.drx*movementY, ((camera.ry - self.mouse_sensibility*camera.dry*movementX) ), camera.rz)
		}
		this.mouseClick=function(){
			
		}
		
		this.mouseRightClick=function(){
			
		}
		
		
		this.addMouseControls(this.mouseMove, this.mouseClick, this.mouseRightClick)
				
		this.setAbsoluteControls(camera, actions)
	}
	
	
	//this.loop=function(){
	this.test=function(){
		var any=false
		for(var key in self.keys_actions){
			if(map[key]){
				self.keys_actions[key]()
			}
			any=any||map[key]
			map['any']=any;
		}
		// setTimeout(self.loop,10);
	}
	
	
	this.init=function(){
		this.mouse_sensibility=0.1
		this.setMode("fps")
		this.setDirections()
		//ex : this.keys_actions = {ArrowUp : function_up, ArrowDown:function_down, ...}
		this.keys_actions={}
		Environment3d.addController(this)
		//this.loop()
	}
	this.init()
}

Sprite=function(x,y,z, width, height, img, width_sprite, height_sprite, dt, cols, rows){
	var self=this
	
	if(width_sprite){
		var texture=new Texture({'url' : img, 'height':height_sprite, 'width':width_sprite, 'background-position':'0 0', 'transform':'scale(' + (width/width_sprite) +',' + (height/height_sprite) + ')'})		
	}
	else{
		var texture=new Texture({'url' : img, 'background-position':'0 0', 'background-size':'100% 100%'})		
	}
	
	Rectangle.call(this,x, y, z, width, height, texture);
	
	this.init=function(x,y,z, width, height, img,  width_sprite, height_sprite, dt, cols, rows=undefined){
		this.fixed=false
		this.img=img
		this.width=width
		this.height=height
		this.width_sprite=width_sprite
		this.height_sprite=height_sprite
		this.position={'x':0, 'y':0}
		this.dt=dt
		this.cols=cols
		this.rows=rows
		this.type='sprite';
		this.name='sprite';
		this.wrap.className+=" sprite"
		
		this.setTransformOrigin('center', 'bottom')
		this.move(this.x,this.y,this.z,0,180,0)
		this.solid=false
	
		//faire face...
		this.controller=new Controller();
		this.controller.keys_actions["any"]=this.render
		this.controller.addMouseControls(this.render)
		this.animate()
	}
	
	this.animate=function(){
		if(!this.dt){return;}
		if(!this.rows){
			this.wrap.firstChild.style.backgroundPosition="0 -" + (this.width_sprite*this.cols) + "px";
			this.wrap.firstChild.style.animation="playX "+ this.dt + "s " + "steps(" + this.cols + ") infinite"
		}
		else{
			
			
			// this.wrap.firstChild.style.animation="playX "+ this.dt + "ms " + "steps(" + (this.cols - 1) + ") infinite, playY "+ this.dt*(this.cols) + "ms " + "steps(" + (this.rows - 1) + ") infinite"
			this.wrap.firstChild.style.backgroundPosition=(this.width_sprite*this.cols) + "px " + (this.height_sprite*this.rows) + "px";
			this.wrap.firstChild.style.animation="playX "+ (this.dt/(this.cols*this.rows)) + "s " + "steps(" + this.cols + ") infinite, playY "+ (this.dt/this.cols) + "s " + "steps(" + this.rows + ") infinite"
			// this.wrap.firstChild.style.animation="playX "+ this.dt + "ms " + "steps(" + (this.cols-1) + ") infinite"
		}
	}
		
	//attention, créer des contrôles de caméra avant la skybox pour éviter le décalage
	this.render=function(){
		if(this.fixed){return;}
		self.rotateOrder=self.theater.world.rotateOrder
		var rx=self.rx
		var ry=self.theater.camera.angleObject(self)
		var rz=self.rz
		var x=self.x
		var y=self.y
		self.move(x, y, z, rx, 90 + ry, rz);
	}
	
	
	
	this.stop=function(){
		this.wrap.firstChild.style.animation="none"
	}
		
	this.init(x,y,z,width,height, img,width_sprite, height_sprite, dt,cols, rows)
}

Collider=function(object){
	var self=this;
	
	this.setControlPoints=function(){
		this.control_points=[];
		switch(this.object.type){
			case 'perso':
				// this.control_points.push(x=>[self.object.x, self.object.y , self.object.z])
				this.control_points.push(x=>[self.object.x+12, self.object.y , self.object.z])
				this.control_points.push(x=>[self.object.x-12, self.object.y , self.object.z])
				this.control_points.push(x=>[self.object.x, self.object.y , self.object.z+12])
				this.control_points.push(x=>[self.object.x, self.object.y , self.object.z-12])
				this.control_points.push(x=>[self.object.x, self.object.y - 0.33*self.object.height, self.object.z])
				this.control_points.push(x=>[self.object.x, self.object.y - 0.66*self.object.height, self.object.z])
				this.control_points.push(x=>[self.object.x, self.object.y -self.object.height+10, self.object.z])
			break;
			default:
				this.control_points.push(x=>[self.object.x, self.object.y, self.object.z])
				this.control_points.push(x=>[self.object.x+self.object.repere.u*self.object.width, self.object.y, self.object.z])
				this.control_points.push(x=>[self.object.x, self.object.y+self.object.repere.v*self.object.height, self.object.z])
				this.control_points.push(x=>[self.object.x+self.object.repere.u*self.object.width, self.object.y+self.object.repere.v*self.object.height, self.object.z])
				if(self.object.depth!=0){					
					this.control_points.push(x=>[self.object.x, self.object.y, self.object.z + self.object.depth])
					this.control_points.push(x=>[self.object.x+self.object.repere.u*self.object.width, self.object.y, self.object.z+ self.object.depth])
					this.control_points.push(x=>[self.object.x, self.object.y+self.object.repere.v*self.object.height, self.object.z+ self.object.depth])
					this.control_points.push(x=>[self.object.x+self.object.repere.u*self.object.width, self.object.y+self.object.repere.v*self.object.height, self.object.z+ self.object.depth])
				}
			break;
		}
	}
		
	
	this.test_collision=function(object_solid){
		if(!object_solid.solid || !this.object.solid || (this===object_solid) ){return false;}
		for(var i=0;i<this.control_points.length;i++){
			if(["box", "cube"].indexOf(object_solid.type)>-1){
				if(Collider.pointInsideBox(this.control_points[i](), object_solid)){return true;}
			}
			else if(object_solid.type=="rectangle"){
				// if(Collider.segmentThrought(this.control_points[i](), this.object.posPrev(), object_solid)){
				if(Collider.segmentThrought(this.control_points[i](), this.object.pos(), object_solid)){
					return true;
				}
			}
			else{
				console.log("Type objet solide non prévu : " + object_solid.type)
			}
		}
		return false;
	}
	
	this.test_collisions=function(objects){
		for(var i=0;i<objects.length;i++){
			if(this.test_collision(objects[i])){return i}
		}
		return -1;
	}
	
	this.init=function(object){
		this.object=object;
		this.theater=this.object.theater
		this.setControlPoints()
	}
	this.init(object)
}
//du côté orienté par le vecteur normal
Collider.pointPositiveSide=function(M, rect){
	return vecProdScal(vec(rect.center, M), rect.normal)>0
}

//Si arguments = M, A, B
//PA plan passant par A ortho à AB
//PB plan passant par B ortho à AB
//teste si point M entre A et B
//Si arguments supplémentaires (C et D, ...)
//on vérifie en plus que M est entre C et D (etc...)
Collider.pointBetween=function(M, A, B, ...args){
	var AB=vec(A,B)
	var test=(vecProdScal(vec(A,M), AB)>0) && (vecProdScal(vec(M,B), AB)>0)
	if(!test){return false;}
	for(var i=0; i<args.length;i+=2){
		var C=args[i]
		var D=args[i+1]
		test=test && Collider.pointBetween(M,C,D)
		if(!test){return false;}
	}
	return test;
}
//projeté ortho de M sur la face rect, et M côté positif
Collider.pointAbove=function(M, rect){
	return Collider.pointPositiveSide(M, rect) && Collider.pointBetween(M, rect.points[0], rect.points[1], rect.points[1], rect.points[2])
}
//projeté ortho de M sur la face rect, et M côté négatif
Collider.pointBeneath=function(M, rect){
	return !Collider.pointPositiveSide(M, rect) && Collider.pointBetween(M, rect.points[0], rect.points[1], rect.points[1], rect.points[2])
}
//le segment M0M1 intersecte rect
Collider.segmentThrought=function(M0, M1, rect){
	return Collider.pointBetween(M0, rect.points[0], rect.points[1], rect.points[1], rect.points[2]) && Collider.pointBetween(M1, rect.points[0], rect.points[1], rect.points[1], rect.points[2]) && (Collider.pointPositiveSide(M0, rect) != Collider.pointPositiveSide(M1, rect))
}
Collider.pointInsideBox=function(M,box){
	var points=[M]
	for(var i=0; i<box.enveloppe.length; i++){
		points.push(box.points[box.enveloppe[i]])
	}
	return Collider.pointBetween.apply(null, points);
}




createElement=function(tagname, args){
	var el=document.createElement(tagname)
	for(var attr in args){
		switch(attr){
			case "className":
				el.className+=args["className"]
			break;
			default:
				el[attr]=args[attr]
			break;			
		}
	}
	return el;

}

Array.prototype.norm = function() {
	var s=0
	for(var i=0;i<this.length;i++){
		s+=Math.pow(this[i],2)
	}
	return Math.sqrt(s)
}

Array.prototype.normalize = function() {
	var length=this.norm()
	for(var i=0;i<this.length;i++){
		this[i]=this[i]/length
	}
	return this;
}

Array.prototype.containObject = function(obj) {
	var length=this.norm()
	for(var i=0;i<this.length;i++){
		if(this[i]===obj){return true}
	}
	return false;
}

function vecSum(...vecs) {
    var s=[]
	if(vecs.length==0){return s;}
	for(var i=0;i<vecs[0].length;i++){
		s.push(0);
		for(var k=0;k<vecs.length;k++){			
			s[i]+=vecs[k][i]
		}
	}
	return s;
}

function vec(A, B){
	var AB=[]
	for(var i=0; i < A.length ; i++){
		AB.push(B[i]-A[i])
	}
	return AB;
}

function vecProd(k, v){
	var kv=[]
	for(var i=0;i<v.length;i++){
		kv.push(k*v[i])
	}
	return kv;
}

function vecProdScal(u, v){
	var uv=0
	for(var i=0;i<u.length;i++){
		uv+=u[i]*v[i]
	}
	return uv;
}

function vecProdVect(u, v){
	return [u[1]*v[2] - u[2]*u[1], u[2]*v[0] - u[0]*v[2], u[0]*v[1] - u[1]*v[0]];
}

function vecOp(v){
	var ov=[]
	for(var i=0;i<v.length;i++){
		ov.push(-v[i])
	}
	return ov;
}

JSON.clone = function(x) {
	return  JSON.parse(JSON.stringify(x));
}


function sind(angleDegres) {
    return Math.sin(angleDegres*Math.PI/180);
};
function cosd(angleDegres) {
    return Math.cos(angleDegres*Math.PI/180);
};
function tand(angleDegres) {
    return Math.tan(angleDegres*Math.PI/180);
};