///////////////////////////////////////
//    exemple basique de scène 3d    //
//           (à modifier)            //
///////////////////////////////////////

/* initialisation de la scène */
	//élément html affichant la scène
	var theater = document.querySelector(".theater");
	//initialisation de l'environnement 3d dans la div theater
	var game=new Environment3d(theater);

/* préparation du sol */
	//texture du sol définie à l'aide de propriétés CSS
	texture_sol=new Texture({'background-image':'linear-gradient(to right, #f3cfbc , #ce8a66)', 'border':'solid #cccccc 1px'})//coloré
	//dimensions du sol
	var largeur_sol=1000;
	var longueur_sol=1000;
	//sol est un rectangle (initialement vertical, le coin en bas à gauche placé à l'origine du repère
	var sol=new Rectangle(0,0,0,largeur_sol,longueur_sol,texture_sol)
	//le centre de rotation du rectangle est placé en bas à droite
	sol.setTransformOrigin('left','bottom')
	//déplacements du sol :
	//les 3 premièrs arguments sont les translation en x, y et z (ici ça bouhe pas)
	//les 3 dernies arguments sont les rotations en x, y et z (on couche le rectangle en effectuant une rotation de -90 degré autour de l'axe des x)
	sol.move(0,0,0,-90,0,0)

/* préparation du cube */
	//les coordonnées du cube (x et z centrées par rapport au sol)
	var x_cube1=largeur_sol/2
	var y_cube1=0
	var z_cube1=longueur_sol/2
	var hauteur_cube1=120;
	//on peu directement donner une image comme texture d'un objet (il est aussi possible de donner des textures pour chaque face ou ne pas mettre certaines faces...)
	var norman_cube=new Cube(x_cube1,y_cube1,z_cube1, hauteur_cube1, "images/Norman_Cube.png")
	//afficher que certaines faces du cube : ajouter arg {top:texture_top, bottom:false, right:false, left:texture_left, front:false, back:false}
	//par défaut le centre de rotation du cube est le point centré à l'intérieur du cubee

/* préparation d'un sprite fixe */
	var x_chuck = x_cube1
	var y_chuck = hauteur_cube1
	var z_chuck = z_cube1 + hauteur_cube1/2
	var largeur_chuck = 150
	var hauteur_chuck = 260
	chuck=new Sprite(x_chuck,y_chuck,z_chuck, largeur_chuck, hauteur_chuck, "images/chuck.png")

/* préparation d'un sprite animé */
	// Sprite=function(x,y,z, width, height, img, width_sprite, height_sprite, dt, cols, rows){
	var x_feu = x_cube1 - 2*hauteur_cube1
	var y_feu = 0
	var z_feu = z_cube1
	var largeur_feu = 200
	var hauteur_feu = 200
	//les étapes du sprite dans l'image chuck.png sont composées de petites images de largeur 256px par une hauteur de 256px réparties sur 3 colonnes et 4 lignes. On veut séparer l'affichage de chaque image de 4ms
	var largeur_img_feu=256
	var hauteur_img_feu=256
	var colonnes_feu=3
	var lignes_feu=4
	var dt=4
	var feu=new Sprite(x_feu,y_feu,z_feu, largeur_feu, hauteur_feu, "images/feu.png", largeur_img_feu, hauteur_img_feu, dt, colonnes_feu, lignes_feu)

/* préparation de la caméra/perso */
	var x_perso = largeur_sol/2
	var y_perso = 0
	var z_perso= 0
	var h_perso=200
	var perso=new Perso(x_perso,y_perso,z_perso, h_perso)
	//vitesse de déplacement du perso
	perso.dx=20
	perso.dy=20
	perso.dz=20

/* préparation de la skybox */
	//l'image de la skybox doit avoir la forme d'un patron de cube (voir image skybox-blue.png)
	// skybox=new Skybox('images/skybox-blue.png')
	var skybox=new Skybox('images/skybox-blue.png');
	//afficher que certaines parties de la skybox : ajouter arg {top:true, bottom:true, right:true, left:true, front:true, back:true}

/* Ajout des objets à la scène */
	game.addObject(skybox)
	game.addObject(sol)
	game.addObject(feu)
	game.addObject(chuck)
	game.addObject(norman_cube)
	game.addObject(perso)
	//activer le personnage comme caméra par défaut (seulement après ajout)
	perso.activate() 